module ndc.

%% Test examples for proof by analogy.

import ndcopy formulas nprfex.

type    testcopy_aux    (goal -> goal -> goal -> goal -> o) ->
                         name -> name -> form -> nprf -> form -> nprf ->
                          goal -> goal -> o.
type    testcopy        int -> form -> nprf -> form -> nprf ->
                          goal -> goal -> o.

testcopy_aux Tac Name1 Name2 F1 P1 F2 P2 GOutGoal TOutGoal :-
  formula Name1 F1,
  proofex Name1 P1,
  formula Name2 F2,
  Tac (nil --> P1 # F1) GOutGoal (nil --> P2 # F2) TOutGoal.

testcopy 1 F1 P1 F2 P2 OutGoal1 OutGoal2 :-
  testcopy_aux exactcopy distrib_quant1 distrib_quant2
           F1 P1 F2 P2 OutGoal1 OutGoal2.

testcopy 2 F1 P1 F2 P2 OutGoal1 OutGoal2 :-
  testcopy_aux orcopy distrib_quant2 distrib_quant3 F1 P1 F2 P2 OutGoal1 OutGoal2.

testcopy 3 F1 P1 F2 P2 OutGoal1 OutGoal2 :-
  testcopy_aux exactcopy cases2 cases3 F1 P1 F2 P2 OutGoal1 OutGoal2.

testcopy 4 F1 P1 F2 P2 OutGoal1 OutGoal2 :-
  testcopy_aux orcopy cases2 cases3 F1 P1 F2 P2 OutGoal1 OutGoal2.
