module goalred.

import  goals.

type    goalreduce      goal -> goal -> o.
type    remove_tt       goal -> goal -> o.

goalreduce (Goal1 && Goal2) RGoal :- !,
  goalreduce Goal1 RGoal1, goalreduce Goal2 RGoal2,
  remove_tt (RGoal1 && RGoal2) RGoal.
goalreduce (all Param Goal) RGoal :- !,
  pi T\ (goalreduce (Goal T) (RGoal1 T)),
  remove_tt (all Param RGoal1) RGoal.
goalreduce (D ==>> Goal) RGoal :- !,
  goalreduce Goal RGoal1, remove_tt (D ==>> RGoal1) RGoal.
goalreduce Goal Goal.

remove_tt (Goal && tt) Goal :- !.
remove_tt (tt && Goal) Goal :- !.
remove_tt (all Param T\tt) tt :- !.
remove_tt (D ==>> tt) tt :- !.
remove_tt Goal Goal.
